# Copyright (c) 2000-2010, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#


Name:           sat4j
Version:        2.1.1
Release:        3%{?dist}
Summary:        A library of SAT solvers written in Java

Group:          Development/Libraries
License:        EPL or LGPLv2
URL:            http://www.sat4j.org/
# Created by sh %{name}-fetch.sh
Source0:        %{name}-%{version}.tar.lzma
Source1:        %{name}-settings.xml
Source2:        %{name}-jpp-depmap.xml
Source3:        %{name}-fetch.sh
Patch0:         %{name}-pom.patch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

BuildRequires:  jpackage-utils >= 0:1.7.5
BuildRequires:  java-devel >= 1.6
BuildRequires:  maven2 >= 0:2.0.8
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-source
BuildRequires:  maven-release
BuildRequires:  maven-surefire-maven-plugin
BuildRequires:  maven-surefire-provider-junit4
BuildRequires:  mojo-maven2-plugin-cobertura
BuildRequires:  apache-commons-parent
BuildRequires:  lzma

Requires:       java >= 1.6
Requires:       jpackage-utils >= 0:1.7.5

BuildArch:      noarch

%description
The aim of the SAT4J library is to provide an efficient library of SAT
solvers in Java. The SAT4J library targets first users of SAT "black
boxes", those willing to embed SAT technologies into their application
without worrying about the details.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
Javadoc for %{name}.

%prep
%setup -q
for j in $(find . -name "*.jar"); do
    mv $j $j.no
done
%patch0 -b .sav0
mkdir external_repo
ln -s %{_javadir} external_repo/JPP
cp -p %{SOURCE1} settings.xml
sed -i -e "s|<url>__JPP_URL_PLACEHOLDER__</url>|<url>file://`pwd`/.m2/repository</url>|g" settings.xml
sed -i -e "s|<url>__JAVADIR_PLACEHOLDER__</url>|<url>file://`pwd`/external_repo</url>|g" settings.xml
sed -i -e "s|<url>__MAVENREPO_DIR_PLACEHOLDER__</url>|<url>file://`pwd`/.m2/repository</url>|g" settings.xml
sed -i -e "s|<url>__MAVENDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/maven2/plugins</url>|g" settings.xml
sed -i -e "s|<url>__ECLIPSEDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/eclipse/plugins</url>|g" settings.xml

%build
export SETTINGS=$(pwd)/settings.xml
export MAVEN_REPO_LOCAL=$(pwd)/.m2/repository
mkdir -p ${MAVEN_REPO_LOCAL}
export MAVEN_OPTS="-Xmx500m -Dmaven2.jpp.depmap.file=%{SOURCE2} -Dmaven.repo.local=${MAVEN_REPO_LOCAL} -Dmaven.test.failure.ignore=true"
%{_bindir}/mvn-jpp \
        -e \
        -s ${SETTINGS} \
        install javadoc:javadoc


%install
rm -rf $RPM_BUILD_ROOT

install -d -m 755 $RPM_BUILD_ROOT%{_javadir}/%{name}

install -m 644 org.sat4j.core/target/org.sat4j.core-2.1.0.jar \
       $RPM_BUILD_ROOT%{_javadir}/%{name}/core-%{version}.jar
install -m 644 org.sat4j.core/target/org.sat4j.core-2.1.0-tests.jar \
       $RPM_BUILD_ROOT%{_javadir}/%{name}/core-tests-%{version}.jar

install -m 644 org.sat4j.csp/target/org.sat4j.csp-2.1.0.jar \
       $RPM_BUILD_ROOT%{_javadir}/%{name}/csp-%{version}.jar
install -m 644 org.sat4j.csp/target/org.sat4j.csp-2.1.0-tests.jar \
       $RPM_BUILD_ROOT%{_javadir}/%{name}/csp-tests-%{version}.jar

install -m 644 org.sat4j.csp.xmlparser/target/org.sat4j.csp.xmlparser-2.1.0.jar \
       $RPM_BUILD_ROOT%{_javadir}/%{name}/csp-xmlparser-%{version}.jar
install -m 644 org.sat4j.csp.xmlparser/target/org.sat4j.csp.xmlparser-2.1.0-tests.jar \
       $RPM_BUILD_ROOT%{_javadir}/%{name}/csp-xmlparser-tests-%{version}.jar

install -m 644 org.sat4j.maxsat/target/org.sat4j.maxsat-2.1.0.jar \
       $RPM_BUILD_ROOT%{_javadir}/%{name}/maxsat-%{version}.jar
install -m 644 org.sat4j.maxsat/target/org.sat4j.maxsat-2.1.0-tests.jar \
       $RPM_BUILD_ROOT%{_javadir}/%{name}/maxsat-tests-%{version}.jar

install -m 644 org.sat4j.multicore/target/org.sat4j.multicore-2.1.0.jar \
       $RPM_BUILD_ROOT%{_javadir}/%{name}/multicore-%{version}.jar
install -m 644 org.sat4j.multicore/target/org.sat4j.multicore-2.1.0-tests.jar \
       $RPM_BUILD_ROOT%{_javadir}/%{name}/multicore-tests-%{version}.jar

install -m 644 org.sat4j.pb/target/org.sat4j.pb-2.1.0.jar \
       $RPM_BUILD_ROOT%{_javadir}/%{name}/pb-%{version}.jar
install -m 644 org.sat4j.pb/target/org.sat4j.pb-2.1.0-tests.jar \
       $RPM_BUILD_ROOT%{_javadir}/%{name}/pb-tests-%{version}.jar

install -m 644 org.sat4j.sat/target/org.sat4j.sat-2.1.0.jar \
       $RPM_BUILD_ROOT%{_javadir}/%{name}/sat-%{version}.jar
install -m 644 org.sat4j.sat/target/org.sat4j.sat-2.1.0-tests.jar \
       $RPM_BUILD_ROOT%{_javadir}/%{name}/sat-tests-%{version}.jar

(cd %{buildroot}%{_javadir}/%{name} && for jar in *-%{version}.jar; do %__ln_s ${jar} `echo $jar| sed "s|-%{version}||g"`; done)

# javadoc
%__mkdir_p %{buildroot}%{_javadocdir}/%{name}-%{version}/core
%__cp -pr org.sat4j.core/target/site/apidocs/* %{buildroot}%{_javadocdir}/%{name}-%{version}/core
%__mkdir_p %{buildroot}%{_javadocdir}/%{name}-%{version}/csp
%__cp -pr org.sat4j.csp/target/site/apidocs/* %{buildroot}%{_javadocdir}/%{name}-%{version}/csp
%__mkdir_p %{buildroot}%{_javadocdir}/%{name}-%{version}/csp-xmlparser
%__cp -pr org.sat4j.csp.xmlparser/target/site/apidocs/* %{buildroot}%{_javadocdir}/%{name}-%{version}/csp-xmlparser
%__mkdir_p %{buildroot}%{_javadocdir}/%{name}-%{version}/maxsat
%__cp -pr org.sat4j.maxsat/target/site/apidocs/* %{buildroot}%{_javadocdir}/%{name}-%{version}/maxsat
%__mkdir_p %{buildroot}%{_javadocdir}/%{name}-%{version}/multicore
%__cp -pr org.sat4j.multicore/target/site/apidocs/* %{buildroot}%{_javadocdir}/%{name}-%{version}/multicore
%__mkdir_p %{buildroot}%{_javadocdir}/%{name}-%{version}/pb
%__cp -pr org.sat4j.pb/target/site/apidocs/* %{buildroot}%{_javadocdir}/%{name}-%{version}/pb
%__mkdir_p %{buildroot}%{_javadocdir}/%{name}-%{version}/sat
%__cp -pr org.sat4j.sat/target/site/apidocs/* %{buildroot}%{_javadocdir}/%{name}-%{version}/sat
%__ln_s %{name}-%{version} %{buildroot}%{_javadocdir}/%{name}


%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root,-)
%dir %{_javadir}/%{name}
%{_javadir}/%{name}/*.jar

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/*

%changelog
* Tue Oct 12 2010 Ralph Apel <r.apel@r-apel.de> 2.1.1-4
- Adapt to JPP6
- Build tests and javadoc
- Build with maven2

* Tue Mar 30 2010 Andrew Overholt <overholt@redhat.com> 2.1.1-3
- Fix license tag

* Fri Mar 26 2010 Alexander Kurtakov <akurtako@redhat.com> 2.1.1-2
- Switch to lzma tarball.
- Remove classpath in manifest.

* Sun Mar 7 2010 Alexander Kurtakov <akurtako@redhat.com> 2.1.1-1
- Update to 2.1.1.

* Tue Aug 4 2009 Alexander Kurtakov <akurtako@redhat.com> 2.1.0-1
- Update to 2.1.0 final.

* Wed Apr 8 2009 Alexander Kurtakov <akurtako@redhat.com> 2.1.0-0.1.rc2
- Update to 2.1.0.RC2.

* Thu Feb 26 2009 Alexander Kurtakov <akurtako@redhat.com> 2.0.3-1
- Update to 2.0.3.

* Wed Feb 25 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 2.0.0-8
- Rebuilt for https://fedoraproject.org/wiki/Fedora_11_Mass_Rebuild

* Thu Aug 28 2008 Andrew Overholt <overholt@redhat.com> 2.0.0-7
- eclipse_base is now libdir/eclipse

* Tue Jul 15 2008 Andrew Overholt <overholt@redhat.com> 2.0.0-6
- Build with OpenJDK (java.util.Scanner)

* Tue Jul 15 2008 Andrew Overholt <overholt@redhat.com> 2.0.0-5
- Use sed instead of dos2unix

* Mon Jul 14 2008 Andrew Overholt <overholt@redhat.com> 2.0.0-4
- Remove jmock JARs
- Don't run tests as part of build

* Mon Jul 14 2008 Andrew Overholt <overholt@redhat.com> 2.0.0-3
- Remove Class-Path from pb MANIFEST.MF

* Mon Jul 14 2008 Andrew Overholt <overholt@redhat.com> 2.0.0-2
- Add eclipse-pde BR for pdebuild script

* Fri Jun 27 2008 Andrew Overholt <overholt@redhat.com> 2.0.0-1
- 2.0.0
- Run tests

* Thu Mar 13 2008 Andrew Overholt <overholt@redhat.com> 2.0-0.1.RC5
- Initial version
